/* @(#)00 1.2.1.3 src/wand/wand/cdsso/cdssotypes.h, pdweb.cdsso, amweb410, 020529a 8/4/01 16:45:37
 *
 * Component Name: pdweb.cdsso
 * File Name: cdssotypes.h
 *
 * Licensed Materials - Property of IBM
 * 5748-XX8
 * (c) Copyright International Business Machines Corp. 2000,2001
 * US Government Users Restricted Rights - Use, duplicaion or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * All Rights Reserved.
 */

#ifndef _CDSSOTYPES_H
#define _CDSSOTYPES_H

#include "stdlib.h"

/*
 * MACROS for memory management
 * Always use these to avoid trouble
 */
#define CDSSO_MALLOC(size)  malloc(size)
#define CDSSO_FREE(ptr) \
    if (ptr) \
    { \
        free(ptr); \
    }
    
#define CDSSO_STRDUP(dst, src) \
    if (src) \
    { \
        dst = (char *) strdup(src); \
    }
    
#define CDSSO_FREE_STR(str) \
    if (str) \
    { \
        free(str); \
    }        

#define CDSSO_REALLOC(curr_ptr, new_size) realloc(curr_ptr, new_size) 
    
/*
 * Type representing a user attribute
 */
typedef struct cdsso_user_attr
{
    char               *attr_name;
    size_t             num_values;
    char               **attr_values;
} cdsso_usr_attr_t;


/*
 * Type representing a list of user attributes
 */
typedef struct cdsso_attrlist
{
    size_t           len;  
    cdsso_usr_attr_t **list;
} cdsso_attrlist_t;


/*
 * Type that holds information about a CDSSO participant 
 */
typedef struct cdsso_user_info
{
    char             *user;
    char             *domain;
    cdsso_attrlist_t *attr_list;
} cdsso_user_info_t;

/*
 * Used to pass information through to the ivauthn layer.
 */
typedef struct ivauthn_cdsso_info {
    char             *user;
    char             *domain;
    cdsso_attrlist_t *attrlist;
} ivauthn_cdsso_info_t;

#endif /* include guard */

