/* @(#)88       1.4 src/ivauthn/modules/pdxauthn/pdxauthn/xattr.h, pdweb.authn, amweb410, 020529a 2/14/02 14:22:34 */
/*
 * xattr.h
 *
 * External attributes utility functions
 */

#ifndef XATTR_H
#define XATTR_H

#if defined(__cplusplus)
extern "C" {
#endif

typedef struct {
    char *name;
    char *value;
} xattr_list_item_t;

typedef struct {
    long               length;
    xattr_list_item_t  *items;
} xattr_list_t;

#include <pdxauthn_decl.h>

/*
 * Allocates an xattr_list_t and returns it.  Returns NULL on allocation
 * failure.
 */
PDXUTILS_DECLSPEC
xattr_list_t*
PDXUTILS_CALLTYPE
xattr_malloc(int list_size);

/*
 * Frees an xattr_list_t and any items in the list.
 */
PDXUTILS_DECLSPEC
void
PDXUTILS_CALLTYPE
xattr_free(xattr_list_t *list);

/*
 * Return a pointer pointing to the value of 
 * the specified name in the xattr.
 */
PDXUTILS_DECLSPEC
int
PDXUTILS_CALLTYPE
xattr_get(xattr_list_t *list, char *name, char **value);

/*
 * Set the name/value pair to the xattr.
 */
PDXUTILS_DECLSPEC
int 
PDXUTILS_CALLTYPE
xattr_set(xattr_list_t *list, char *name, char *value);

/*
 * Duplicate the xnvlist.
 */
PDXUTILS_DECLSPEC
xattr_list_t *
PDXUTILS_CALLTYPE
xattr_dup(xattr_list_t *list);

/*
 * Duplicate the items in the xattr.
 */
PDXUTILS_DECLSPEC
xattr_list_item_t *
PDXUTILS_CALLTYPE
xattr_items_dup(xattr_list_t *list);

#if defined(__cplusplus)
}
#endif

#endif /* end XATTR_H */
